local AddonName, a = ...
local L = a.Localize
local s = SpellFlashAddon
local c = BittensSpellFlashLibrary

local GetPowerRegen = GetPowerRegen
local GetTime = GetTime
local math = math

function a.FocusAdded()
    local added = 9
    if c.WearingSet(2, "T13") then
        added = added + 9
    end
    if s.HealthPercent() <= 25 then
        added = added + 3 * c.GetTalentRank("Termination")
    end
    return added
end

local function adjustCost(info)
    if c.InfoMatches(info, "Cobra Shot", "Steady Shot") then
        info.Cost = -a.FocusAdded()
    end
end

a.Focus = 0
a.Rotations = {}
c.RegisterForEvents(a)
s.Spam[AddonName] = function()
    c.Init(a)
    local _, regen = GetPowerRegen()
    adjustCost(c.GetCastingInfo())
    adjustCost(c.GetQueuedInfo())
    a.Focus = math.floor(c.GetPower(regen))
    c.Flash(a)
end

----------------------------------------------------------------- Beast Mastery
a.Rotations.BeastMastery = {
    Spec = 1,
    OffSwitch = "bm_off",
    
    FlashInCombat = function()
        a.FlashAll(
            "Hunter's Mark", 
            "Bestial Wrath", 
            "Focus Fire",
            "Fervor")
        
        if a.Flash(
           "Kill Command",
           "Serpent Sting", 
           "Kill Shot") then
           
           return
        end
        
        if a.Focus > 70 or c.HasBuff("The Beast Within") then
            a.Flash("Arcane Shot")
        else
            a.Flash("Cobra Shot")
        end
    end,
    
    FlashAlways = function()
       a.FlashAll("Aspect of the Hawk", "Mend Pet", "Call Pet")
    end,
}

------------------------------------------------------------------ Marksmanship
a.Rotations.Marksmanship = {
    Spec = 2,
    OffSwitch = "marks_off",
    
    FlashInCombat = function()
--c.Debug(a.Focus, 
        a.Flash(
            "Steady Shot 2",
            "Serpent Sting unless Careful Aim",
            "Chimera Shot",
            "Aimed Shot!",
            "Steady Shot No Buff",
            "Kill Shot",
            "Rapid Fire if Talented",
            "Readiness",
            "Marksmanship Focus Dump",
            "Steady Shot Refresh Buff",
            "Kill Command under Resistance is Futile",
            "Steady Shot")
--, GetTime() + c.GetBusyTime())
    end,
    
    FlashAlways = function()
        a.FlashAll("Aspect of the Hawk", "Mend Pet", "Call Pet")
    end,
    
    CastStarted = function(info)
        if info.ID == c.GetID("Steady Shot") then
            a.NextSSIsImproved = not a.NextSSIsImproved
            c.Debug("Event",
                "Next is improved:", a.NextSSIsImproved, info.Name, "Started")
        elseif a.NextSSIsImproved then
            a.NextSSIsImproved = false
            c.Debug("Event", "Next is improved: false", info.Name, "Started")
        end
--c.Debug("start", spellID)
    end,
    
    CastSucceeded = function(info)
        if a.NextSSIsImproved
            and not c.InfoMatches(info, "Autoshot", "Steady Shot") then
            
            a.NextSSIsImproved = false
            c.Debug("Event", "Next is improved: false", info.Name, "Succeeded")
        end
--c.Debug("success", spellID)
    end,
}

---------------------------------------------------------------------- Survival
local allowES = true
local lastES = 0

a.Rotations.Survival = {
    Spec = 3,
    OffSwitch = "survival_off",
    
    FlashInCombat = function()
        if GetTime() - lastES > 1 then
            allowES = true
        end
        
        a.FlashAll(
            "Hunter's Mark", 
            "Serpent Sting", 
            "Black Arrow", 
            "Kiroptyric Sigil")
        if allowES and a.Flash("Explosive Shot") then
            return
        end
        if a.Flash("Kill Shot") then
            return
        end
        
        if a.Focus > 60 then
            a.Flash("Arcane Shot")
        else
            a.Flash("Cobra Shot")
        end
    end,
    
    FlashAlways = function()
        a.FlashAll("Aspect of the Hawk", "Mend Pet", "Call Pet")
    end,
    
    CastSucceeded = function(info)
	    if c.InfoMatches(info, "Explosive Shot") then
		    if GetTime() - lastES < 2 then
		        allowES = false
		    end
		    lastES = GetTime()
	        c.Debug("Event", "Explosive Shot Fired")
	    end
    end,
}
